import Foundation

/**
 The phase of a table
 */
enum GamePhase: String, Codable {
    
    /// The table is not yet full, so no game can be started
    case waitingForPlayers = "waiting"
    
    /// The players are specifying if they want to double ("legen")
    case collectingDoubles = "doubles"
    
    /// The game negotiation is ongoing
    case bidding = "bidding"
    
    /// The game is in progress
    case playing = "play"
    
    /// The game is over
    case gameFinished = "done"
}
